#include "DrawComponent.h"

void NormalSwitch::drawIt(TDC& dc) {
	int a(20), b(13);
	if(closed){
		a=13;
		b=20;
	}
	dc.SelectObject(redpen);
	dc.MoveTo(startX, startY);
	dc.LineTo(startX, startY-10);
	dc.LineTo(startX+10, startY-10);

  	dc.MoveTo(startX+8, startY-b);
   dc.SelectObject(ltgraypen);
  	dc.LineTo(startX+20, startY-10);
  	dc.MoveTo(startX+8, startY-a);
   dc.SelectObject(redpen);
   dc.LineTo(startX+20, startY-10);
  	dc.LineTo(startX+30, startY-10);
  	dc.LineTo(startX+30, startY);

  	dc.MoveTo(startX+10, startY-10);
	dc.LineTo(startX+10, startY-15);
   dc.SelectObject(blackpen);
}

bool NormalSwitch::myArea(TPoint& p) {
   return (p.x>startX && p.x<startX+30 && p.y>startY-20 && p.y<startY-10);
}

void R90Switch::drawIt(TDC& dc) {
   int a(20), b(13);
   if(closed){
   	a=13;
    	b=20;
   }
   dc.SelectObject(redpen);
   dc.MoveTo(startX, startY);
	dc.LineTo(startX+10, startY);
  	dc.LineTo(startX+10, startY+10);

  	dc.MoveTo(startX+b, startY+7);
   dc.SelectObject(ltgraypen);
   dc.LineTo(startX+10, startY+20);
   dc.MoveTo(startX+a, startY+7);
   dc.SelectObject(redpen);
   dc.LineTo(startX+10, startY+20);
	dc.LineTo(startX+10, startY+30);
  	dc.LineTo(startX, startY+30);

   dc.MoveTo(startX+10, startY+10);
	dc.LineTo(startX+15, startY+10);
   dc.SelectObject(blackpen);
}

bool R90Switch::myArea(TPoint& p) {
   return (p.x>startX+10 && p.x<startX+20 && p.y>startY && p.y<startY+30);
}

void R180Switch::drawIt(TDC& dc) {
   int a(20), b(13);
   if(closed){
   	a=13;
    	b=20;
   }
	dc.SelectObject(redpen);
   dc.MoveTo(startX, startY);
  	dc.LineTo(startX, startY+10);
	dc.LineTo(startX+10, startY+10);
   dc.SelectObject(ltgraypen);
 	dc.LineTo(startX+23, startY+b);
	dc.MoveTo(startX+10, startY+10);
   dc.SelectObject(redpen);
 	dc.LineTo(startX+23, startY+a);

  	dc.MoveTo(startX+20, startY+15);
	dc.LineTo(startX+20, startY+10);
  	dc.LineTo(startX+30, startY+10);
  	dc.LineTo(startX+30, startY);
   dc.SelectObject(blackpen);
 }

bool R180Switch::myArea(TPoint& p) {
   return (p.x>startX && p.x<startX+30 && p.y>startY+10 && p.y<startY+20);
}

void R270Switch::drawIt(TDC& dc) {
   int a(20), b(13);
   if(closed){
   	a=13;
    	b=20;
   }
	dc.SelectObject(redpen);
   dc.MoveTo(startX, startY);
  	dc.LineTo(startX-10, startY);
	dc.LineTo(startX-10, startY+10);
   dc.SelectObject(ltgraypen);
  	dc.LineTo(startX-b, startY+23);
   dc.MoveTo(startX-10, startY+10);
   dc.SelectObject(redpen);
  	dc.LineTo(startX-a, startY+23);


  	dc.MoveTo(startX-14, startY+20);
	dc.LineTo(startX-10, startY+20);
   dc.LineTo(startX-10, startY+30);
   dc.LineTo(startX, startY+30);
	dc.SelectObject(blackpen);
 }

bool R270Switch::myArea(TPoint& p) {
   return (p.x>startX-20 && p.x<startX-10 && p.y>startY && p.y<startY+30);
}

void NormalResistor::drawIt(TDC& dc){
   dc.SelectObject(blackpen);
   dc.MoveTo(startX, startY);
  	dc.LineTo(startX+10, startY);

	dc.Rectangle(startX+10, startY-6, startX+30, startY+6);

   dc.MoveTo(startX+30, startY);
 	dc.LineTo(startX+40, startY);
   dc.SetTextAlign(TA_CENTER);
	if (!value) {
     dc.TextOut(startX+20, startY+10, name.c_str(), strlen(name.c_str()));
   } else {
      dc.TextOut(startX+20, startY+10, name.c_str(), strlen(name.c_str()));
      char buffer[256];
      ostrstream avalue(buffer, sizeof buffer);
	   avalue<<value<<"k"<<ends;
   	dc.TextOut(startX+20, startY+25, avalue.str(), strlen(avalue.str()));
   }
}

bool NormalResistor::myArea(TPoint& p) {
   return (p.x>startX+10 && p.x<startX+30 && p.y>startY-5 && p.y<startY+5);
}

void R90Resistor::drawIt(TDC& dc){
   dc.SelectObject(blackpen);
   dc.MoveTo(startX, startY);
	dc.LineTo(startX, startY+10);

   dc.Rectangle(startX-6, startY+10, startX+6, startY+30);

  	dc.MoveTo(startX, startY+30);
	dc.LineTo(startX, startY+40);
   dc.SetTextAlign(TA_RIGHT);
   if (!value) {
     dc.TextOut(startX-10, startY+11, name.c_str(), strlen(name.c_str()));
   } else {
      dc.TextOut(startX-10, startY+3, name.c_str(), strlen(name.c_str()));
      char buffer[256];
      ostrstream avalue(buffer, sizeof buffer);
      avalue<<value<<"k"<<ends;
   	dc.TextOut(startX-10, startY+19, avalue.str(), strlen(avalue.str()));
	}
}

bool R90Resistor::myArea(TPoint& p) {
   return (p.x>startX-5 && p.x<startX+5 && p.y>startY+10 && p.y<startY+30);
}

void R90PotRes::drawIt(TDC& dc){
   dc.SelectObject(redpen);
   dc.MoveTo(startX, startY);
	dc.LineTo(startX, startY+10);

   dc.Rectangle(startX-6, startY+10, startX+6, startY+30);

  	dc.MoveTo(startX, startY+30);
	dc.LineTo(startX, startY+40);

   dc.MoveTo(startX+9, startY+7);
	dc.LineTo(startX-9, startY+33);

   dc.LineTo(startX-9, startY+27);

   dc.MoveTo(startX-9, startY+33);
   dc.LineTo(startX-4, startY+33);
   dc.SelectObject(blackpen);

   dc.SetTextAlign(TA_RIGHT);
	if (!value) {
     dc.TextOut(startX-10, startY+11, name.c_str(), strlen(name.c_str()));
   } else {
      dc.TextOut(startX-10, startY+3, name.c_str(), strlen(name.c_str()));
      char buffer[256];
      ostrstream avalue(buffer, sizeof buffer);
      avalue<<value<<"k"<<ends;
		dc.TextOut(startX-10, startY+19, avalue.str(), strlen(avalue.str()));
   }
}

void NormalNode::drawIt(TDC& dc) {
   dc.SelectObject(blackpen);
   dc.MoveTo(startX, startY);
   dc.LineTo(startX+5, startY);
   dc.Arc(startX+5, startY-5, startX+15, startY+5, startX+5, startY, startX+5,
   		startY);
   dc.MoveTo(startX+5, startY+4);
   dc.LineTo(startX+15, startY-6);
	dc.MoveTo(startX+15, startY);
   dc.LineTo(startX+20, startY);
   dc.SetTextAlign(TA_CENTER);
   dc.TextOut(startX+10, startY+10, name.c_str(), strlen(name.c_str()));
}

bool NormalNode::myArea(TPoint& p) {
   return (p.x>startX+5 && p.x<startX+15 && p.y>startY-5 && p.y<startY+5);
}

void R90Node::drawIt(TDC& dc) {
   dc.SelectObject(blackpen);
   dc.MoveTo(startX, startY);
   dc.LineTo(startX, startY+5);
	dc.Arc(startX-5, startY+5, startX+5, startY+15, startX, startY+5, startX,
			startY+5);
	dc.MoveTo(startX-5, startY+14);
	dc.LineTo(startX+5, startY+4);
	dc.MoveTo(startX, startY+15);
	dc.LineTo(startX, startY+20);
   dc.SetTextAlign(TA_RIGHT);
   dc.TextOut(startX-10, startY+2, name.c_str(), strlen(name.c_str()));
}

bool R90Node::myArea(TPoint& p) {
   return (p.x>startX-5 && p.x<startX+5 && p.y>startY+5 && p.y<startY+15);
}


void NormalVSource::drawIt(TDC& dc){
   dc.SelectObject(redpen);
   dc.MoveTo(startX, startY);
  	dc.LineTo(startX+50, startY);

 	dc.Arc(startX+10, startY+15, startX+40, startY-15, startX+10, startY,
   		startX+10, startY);
	dc.SelectObject(blackpen);

	dc.SetTextAlign(TA_CENTER);
   dc.TextOut(startX+5, startY-16, "+", 1);
   dc.TextOut(startX+45, startY-16, "-", 1);
	if (!value) {
	  dc.TextOut(startX+24, startY+15, name.c_str(), strlen(name.c_str()));
   } else {
      dc.TextOut(startX+24, startY+15, name.c_str(), strlen(name.c_str()));
      char buffer[256];
      ostrstream avalue(buffer, sizeof buffer);
      avalue<<"      "<<value<<"mV"<<ends;
   	dc.TextOut(startX+24, startY+30, avalue.str(), strlen(avalue.str()));
   }
}

bool NormalVSource::myArea(TPoint& p) {
   return (p.x>startX+10 && p.x<startX+40 && p.y>startY-15 && p.y<startY+15);
}

void R90VSource::drawIt(TDC& dc){
   dc.SelectObject(redpen);
   dc.MoveTo(startX, startY);
	dc.LineTo(startX, startY+50);

   dc.Arc(startX-15, startY+40, startX+15, startY+10, startX, startY+10, startX,
   		startY+10);
   dc.SelectObject(blackpen);

   dc.SetTextAlign(TA_RIGHT);
   dc.TextOut(startX-1, startY-7, "+", 1);
   dc.TextOut(startX-3, startY+40, "-", 1);
   if (!value) {
     dc.TextOut(startX-20, startY+16, name.c_str(), strlen(name.c_str()));
	} else {
      dc.TextOut(startX-20, startY+8, name.c_str(), strlen(name.c_str()));
      char buffer[256];
      ostrstream avalue(buffer, sizeof buffer);
      avalue<<"      "<<value<<"mV"<<ends;
   	dc.TextOut(startX-20, startY+24, avalue.str(), strlen(avalue.str()));
   }
}

bool R90VSource::myArea(TPoint& p) {
   return (p.x>startX-15 && p.x<startX+15 && p.y>startY+10 && p.y<startY+40);
}

void Gnd::drawIt(TDC& dc) {
	dc.MoveTo(startX, startY);
   dc.LineTo(startX, startY+10);
   dc.MoveTo(startX-5, startY+10);
   dc.LineTo(startX+6, startY+10);
   dc.LineTo(startX+5, startY+11);
   dc.LineTo(startX-5, startY+11);
}

bool Gnd::myArea(TPoint& p) {
   return (p.x>startX && p.x<startX+6 && p.y>startY && p.y<startY+11);
}

void Relais::drawIt(TDC& dc) {
//   dc.SelectObject(reddottedpen);
//   dc.MoveTo(startX, startY);
//   dc.LineTo(startX, startY+10);
	dc.MoveTo(startX-10, startY+15);
   dc.LineTo(startX-15, startY+15);
   dc.SelectObject(redpen);
   dc.Rectangle(startX-10, startY+10, startX+10, startY+20);
//   dc.MoveTo(startX,startY+20);
//   dc.LineTo(startX,startY+30);
   dc.SelectObject(blackpen);
   if (!value) {
     dc.TextOut(startX-20, startY+16, name.c_str(), strlen(name.c_str()));
   } else {
		dc.TextOut(startX-20, startY+8, name.c_str(), strlen(name.c_str()));
      char buffer[256];
      ostrstream avalue(buffer, sizeof buffer);
      avalue<<"      "<<value<<"us"<<ends;
   	dc.TextOut(startX-20, startY+24, avalue.str(), strlen(avalue.str()));
   }
}

bool Relais::myArea(TPoint& p) {
   return (p.x>startX-10 && p.x<startX+10 && p.y>startY+10 && p.y<startY+20);
}
